﻿using System;
using System.Diagnostics;


namespace SpaceInvaders
{
    public abstract class Node
    {
        //------------------------------------------------------------------
        //  PURE VIRTUAL METHODS 
        //------------------------------------------------------------------

        public abstract void Reset();

        public abstract void PrintStats();


        //-------------------------------------------------------------------
        //  VIRTUAL METHODS
        //-------------------------------------------------------------------

        public virtual bool Compare(Node pNode)
        {
            //does nothing by default
            Debug.Assert(false);
            return false;
        }

        public virtual bool ComparePriority(Node pNode)
        {
            //does nothing by default
            Debug.Assert(false);
            return false;
        }

        public virtual object GetName()
        {
            //does nothing by default
            return null;
        }
    }
}